> ## Documentation Index > Fetch the complete documentation index at: https://developers.cmicglobal.com/llms.txt > Use this file to discover all available pages before exploring further. # Retrieve Non-Stock Items By Company Code, Item Code and Cost Code > ## UI Navigation **Asset Management - Purchase Order - Setup - Non Stock Items** ## Overview **Retrieve Non-Stock Items by Company Code, Item Code, and Cost Code:** This endpoint retrieves non-stock items, with option to filter and optimize the request performance using the following Finder. ## Finders The following finders are available for data filtering and optimizing request performance. - NonStockItemFinder ## Path Parameters | Parameter | Description | Example | | --- | --- | --- | | CompCode | Compnay Code | ZZ | | ItemCode | Item Code | DashCam | | CostCode | Cost Code | 03-700 | ## Query Standards | Key | Recommended | Description | | --- | --- | --- | | `finder` | Yes | Filters data based on attributes. See finder details below. Finders can be combined using a comma delimiter between parameters that implies an "and" statement. | | `limit` | Yes | A limit restricts the number of resources returned inside the resource collection. If the limit exceeds the resource count, then the framework will return all available resources. | | `offset` | Yes | The offset skips a specified number of items in a data list before it starts showing results. For example, if you set an offset of 10, it skips the first 10 items and begins showing from the 11th item. | | `orderBy` | Yes | The `orderBy` attribute retrieves rows using an order ensuring the response payload displays data in the order supplied in the URL parameter using the GET method. | ## poNonStockItem Finders | Finder | Parameter | Data Type | Description | Example | Mandatory | | --- | --- | --- | --- | --- | --- | | NonStockItemFinder | PONSI_COMP_CODE | String | Compnay Code | /po-rest-api/rest/1/pononstockitem?finder=NonStockItemFinder.PONSI_COMP_CODE=ALT | Optional | | NonStockItemFinder | PONSI_COST_CODE | String | Cost Code | /po-rest-api/rest/1/pononstockitem?finder=NonStockItemFinder.PONSI_COST_CODE=01.9 | Optional | | NonStockItemFinder | PONSI_ITM_CODE | String | Item Code | /po-rest-api/rest/1/pononstockitem?finder=NonStockItemFinder.PONSI_ITM_CODE=WIDGET 1 | Optional | | PrimaryKey | PONSI_V_UUID | String | UUID -Unique Identifier | /4160BB81A24F71C0E0630B811DACBBBA | False | ## Attributes | CMiC UI Fieldname | Object | Name | Description | Type | Data Length | Example | Mandatory | | --- | --- | --- | --- | --- | --- | --- | --- | | PonsiCompCode | poNonStockItem | PonsiCompCode | Company Code | String | 8 | ALT | True | | PonsiItmCode | poNonStockItem | PonsiItmCode | Item Code | String | 16 | WIDGET 1 | True | | PonsiItmName | poNonStockItem | PonsiItmName | Item Name | String | 60 | Widget 1 | True | | PonsiItmWmCode | poNonStockItem | PonsiItmWmCode | Weight Measure Code | String | 2 | EA | True | | PonsiItmLstPriceAmt | poNonStockItem | PonsiItmLstPriceAmt | Last Price | Number | 18/4 | 20.0 | False | | PonsiItmMinOrdQty | poNonStockItem | PonsiItmMinOrdQty | Min Ord | Number | 6/0 | 1 | False | | PonsiItmTax1Code | poNonStockItem | PonsiItmTax1Code | Tax1 Code | String | 11 | 01 | False | | PonsiItmTax2Code | poNonStockItem | PonsiItmTax2Code | Tax2 Code | String | 11 | T5 | False | | PonsiItmTax3Code | poNonStockItem | PonsiItmTax3Code | Tax3 Code | String | 11 | T6 | False | | PonsiAccCode | poNonStockItem | PonsiAccCode | Account Code | String | 16 | 5000.106 | False | | PonsiInternalSalesAccCode | poNonStockItem | PonsiInternalSalesAccCode | Internal Sales Account Code | String | 16 | 4000.800 | False | | PonsiCatCode | poNonStockItem | PonsiCatCode | Category Code | String | 16 | 4000 | False | | PonsiItmDesc | poNonStockItem | PonsiItmDesc | Item Description | String | 4000 | SALES REV | False | | PonsiCostCode | poNonStockItem | PonsiCostCode | Cost Code | String | 16 | 01.9 | False | | PonsiVUuid | poNonStockItem | PonsiVUuid | Unique Identifier | String | 64 | 4160BB81A24F71C0E0630B811DACBBBA | False | ## OpenAPI ````json GET /po-rest-api/rest/1/poNonStockItem { "openapi": "3.0.0", "info": { "title": "API Catalog", "description": "", "version": "1.0.0" }, "servers": [ { "url": "https://mobtest.cmiccloudr12.com/cmictestrti", "description": "CMIC API Server" } ], "security": [ { "cmicBasicAuth": [] } ], "tags": [ { "name": "Highlights" }, { "name": "Asset Management | Equipment" }, { "name": "Asset Management | Fixed Assets" }, { "name": "Asset Management | Purchase Order" }, { "name": "Asset Management | Inventory" }, { "name": "Asset Management | Requisition" }, { "name": "Bim Model" }, { "name": "Bim Model Revision" }, { "name": "Bim Tag Model" }, { "name": "Bim Tags" }, { "name": "Bim FileUpload Jersey" }, { "name": "Core System | Business Partners" }, { "name": "Core System | Business Partner Addresses" }, { "name": "Core System | Bank" }, { "name": "Core System | Currency" }, { "name": "Core System | Exchange Rates" }, { "name": "Core System | Global Table Text Codes" }, { "name": "Core System | Global Table Regions" }, { "name": "Core System | Terms" }, { "name": "Core System | System Contact" }, { "name": "Core System | Weight Measures" }, { "name": "Core System | Field User Defined Classifiers" }, { "name": "Core System | User Defined Classifiers by Object" }, { "name": "Core System | User Extension Definitions by Object" }, { "name": "Core System | User Extention Field Data Value" }, { "name": "Core System | User Extension Values by Object" }, { "name": "Core System | User System Role" }, { "name": "Core System | User Project Role" }, { "name": "Core System | Documents by Object" }, { "name": "Core System | Audit Status Log by Object" }, { "name": "Core System | Licensed Users" }, { "name": "Core System | Company Access" }, { "name": "Core System | Copy User Settings" }, { "name": "Core System | User Maintenance" }, { "name": "Core System | User Roles" }, { "name": "Core System | Security Groups" }, { "name": "Core System | Job/Project Security" }, { "name": "ECM and Workflow | Image Manager" }, { "name": "Financials | General Ledger" }, { "name": "Financials | Accounts Payable" }, { "name": "Financials | Accounts Receivable" }, { "name": "Preventative Maintenance | Issue Work Orders" }, { "name": "Preventative Maintenance | Issue Work Items" }, { "name": "Preventative Maintenance | Issue Work Budgets" }, { "name": "Preventative Maintenance | Issue Priorities" }, { "name": "Preventative Maintenance | Issue Status" }, { "name": "Preventative Maintenance | Issue Types" }, { "name": "Preventative Maintenance | Accumulative Equipment" }, { "name": "Preventative Maintenance | Work Orders" }, { "name": "Preventative Maintenance | Work Items" }, { "name": "Preventative Maintenance | Work Budgets" }, { "name": "Preventative Maintenance | Priorities" }, { "name": "Preventative Maintenance | Tasks" }, { "name": "HCM | UKG Pay Deductions" }, { "name": "HCM | UKG Pay Earnings" }, { "name": "HCM | UKG Pay Headers" }, { "name": "HCM | UKG Pay Taxes" }, { "name": "HCM | Payroll Geographical States" }, { "name": "HCM | Payroll Trades" }, { "name": "HCM | Payroll Union" }, { "name": "HCM | Payroll Pay Runs" }, { "name": "HCM | Payroll Pay Groups" }, { "name": "HCM | Payroll Tax" }, { "name": "HCM | Payroll Worker Compensation" }, { "name": "HCM | Payroll Work Locations" }, { "name": "HCM | Payroll Trade Pay Rates" }, { "name": "HCM | Payroll Union Pay Rates" }, { "name": "HCM | Payroll Job Pay Rates" }, { "name": "HCM | Payroll Master Benefits" }, { "name": "HCM | Payroll Master Deductions" }, { "name": "HCM | Payroll Ben/Ded/Leave Base Codes" }, { "name": "HCM | Payroll Ben/Ded Plans" }, { "name": "HCM | Payroll Ben/Ded Plan Options" }, { "name": "HCM | Payroll Company Benefits" }, { "name": "HCM | Payroll Company Deductions" }, { "name": "HCM | Payroll Vertex Geographic Locations" }, { "name": "HCM | Payroll Checks" }, { "name": "HCM | Payroll Timesheets" }, { "name": "HCM | Employee" }, { "name": "HCM | Employee (Minimum payload)" }, { "name": "HCM | Employee History" }, { "name": "HCM | Tax Exemptions" }, { "name": "HCM | Employee Tax Overrides" }, { "name": "HCM | Employee Pay Splits" }, { "name": "HCM | Employee Benefits" }, { "name": "HCM | Employee Clock In and Out" }, { "name": "HCM | Employee Deductions" }, { "name": "HCM | Employee Leaves" }, { "name": "HCM | Employee Leave History" }, { "name": "HCM | Employee Hour Types" }, { "name": "HCM | Employee Pay History" }, { "name": "HCM | Employee Work Statuses" }, { "name": "HCM | Employee Security Group" }, { "name": "HCM | Crewtime Crew" }, { "name": "HCM | Crewtime Employee Timesheet" }, { "name": "HCM | Crewtime Equipment Timesheet" }, { "name": "HCM | Crew Maintenance Activity Assignment" }, { "name": "HCM | Crew Maintenance Member Assignment" }, { "name": "HCM | Crew Maintenance Member Trade and Union Assignment" }, { "name": "HCM | Crew Maintenance Equipment Assignment" }, { "name": "HCM | Crew Maintenance Equipment Detail Assignment" }, { "name": "HCM | HR Requisitions" }, { "name": "HCM | HR Relations" }, { "name": "HCM | HR Employee Skills" }, { "name": "HCM | HR Incident" }, { "name": "HCM | HR Employee Relatives / Dependents" }, { "name": "HCM | HR Employee Positions" }, { "name": "HCM | HR Applicants" }, { "name": "HCM | HR Applications" }, { "name": "HCM | Vertex Location City" }, { "name": "HCM | HR Application History" }, { "name": "HCM | HR Dependent Benefits" }, { "name": "HCM | HR Dependent Deductions" }, { "name": "HCM | HR Employee Elected Plans" }, { "name": "HCM | HR Employee Training Certifications" }, { "name": "HCM | HR Trainings" }, { "name": "HCM | E-Timesheets" }, { "name": "HCM | System Contacts" }, { "name": "HCM | System User Payroll Security Group" }, { "name": "HCM | Payroll Timesheet Posting" }, { "name": "HCM | CrewTimesheet Posting" }, { "name": "Materials Management | Material Sale Orders" }, { "name": "Materials Management | Material Sale Orders Details" }, { "name": "Materials Management | Truck Rate Detail" }, { "name": "Opportunity Management | Competitors" }, { "name": "Opportunity Management | Opportunities" }, { "name": "Opportunity Management | Revenue Details" }, { "name": "Opportunity Management | Opportunity History" }, { "name": "Opportunity Management | Organization" }, { "name": "Project Controls | Job Billing" }, { "name": "Project Controls | Job Cost" }, { "name": "Project Controls | PCI Details" }, { "name": "Project Controls | Unposted PCI Details" }, { "name": "Project Controls | PCI Headers" }, { "name": "Project Controls | Owner Change Orders" }, { "name": "Project Controls | RFQ (Request for Quote) Extensions" }, { "name": "Project Controls | CM Statuses" }, { "name": "Project Controls | CM Types" }, { "name": "Project Controls | CM Vendor Details" }, { "name": "Project Controls | Post PCI" }, { "name": "Project Management | Uploading Documents" }, { "name": "Project Management | Downloading Documents" }, { "name": "Project Management | Foreign Bid Item Imports" }, { "name": "Project Management | Communications" }, { "name": "Project Management | Daily Journals" }, { "name": "Project Management | Communications Types" }, { "name": "Project Management | Daily Journal Daily Work Plans" }, { "name": "Project Management | Daily Journal Field Forces" }, { "name": "Project Management | Daily Journal Labour" }, { "name": "Project Management | Daily Journal Materials" }, { "name": "Project Management | Daily Journal Owner Equipment" }, { "name": "Project Management | Daily Journal Quality Control" }, { "name": "Project Management | Daily Journal Tasks" }, { "name": "Project Management | Daily Journal Trade Equipment" }, { "name": "Project Management | Daily Journal Transactions" }, { "name": "Project Management | Daily Journal User Defined Data" }, { "name": "Project Management | Daily Journal Visitors" }, { "name": "Project Management | Daily Journal Bill Details" }, { "name": "Project Management | Field Work Directives" }, { "name": "Project Management | Contract Types" }, { "name": "Project Management | Company Contacts" }, { "name": "Project Management | Distribution BCC" }, { "name": "Project Management | Distribution CC" }, { "name": "Project Management | Field Work Directive Statuses" }, { "name": "Project Management | Issues" }, { "name": "Project Management | Key Players" }, { "name": "Project Management | Meetings" }, { "name": "Project Management | Meeting Attendees" }, { "name": "Project Management | Meeting Item Statuses" }, { "name": "Project Management | Meeting Tracks" }, { "name": "Project Management | Notes" }, { "name": "Project Management | Projects" }, { "name": "Project Management | Project Items" }, { "name": "Project Management | Project Item Phase Segment Sums" }, { "name": "Project Management | Project Partners" }, { "name": "Project Management | Notices" }, { "name": "Project Management | Notice Statuses" }, { "name": "Project Management | Owner JS Query" }, { "name": "Project Management | PCI Real Locations" }, { "name": "Project Management | Project Contacts" }, { "name": "Project Management | RFIs (Requests for Information)" }, { "name": "Project Management | RFI Statuses" }, { "name": "Project Management | Submittal Packages" }, { "name": "Project Management | Submittal Package Details" }, { "name": "Project Management | Submittal Package Status" }, { "name": "Project Management | Submittals" }, { "name": "Project Management | Submittal Status" }, { "name": "Project Management | Transmittals" }, { "name": "Project Management | Subcontract Headers" }, { "name": "Project Management | Subcontract Schedules" }, { "name": "Project Management | Subcontract Sechedule Phase Segment Sums" }, { "name": "Project Management | User Roles" }, { "name": "Project Management | Punchlists" }, { "name": "Project Management | Punchlist Details" }, { "name": "Project Management | Punchlist Statuses" }, { "name": "Project Management | Meeting Items" }, { "name": "Project Management | Self Perform Vendor" }, { "name": "Project Management | Submittal Types" }, { "name": "Project Management | Assign contact and partner to project" }, { "name": "Project Management | Subcontract Prequal" }, { "name": "Project Management | Bid Item Package" } ], "paths": { "/po-rest-api/rest/1/poNonStockItem": { "get": { "tags": [ "Asset Management | Purchase Order" ], "summary": "Retrieve Non-Stock Items By Company Code, Item Code and Cost Code", "description": "## UI Navigation\n\n**Asset Management - Purchase Order - Setup - Non Stock Items**\n\n## Overview\n\n**Retrieve Non-Stock Items by Company Code, Item Code, and Cost Code:**\n\nThis endpoint retrieves non-stock items, with option to filter and optimize the request performance using the following Finder.\n\n## Finders\n\nThe following finders are available for data filtering and optimizing request performance.\n\n- NonStockItemFinder\n \n\n## Path Parameters\n\n| Parameter | Description | Example |\n| --- | --- | --- |\n| CompCode | Compnay Code | ZZ |\n| ItemCode | Item Code | DashCam |\n| CostCode | Cost Code | 03-700 |\n\n## Query Standards\n\n| Key | Recommended | Description |\n| --- | --- | --- |\n| `finder` | Yes | Filters data based on attributes. See finder details below. Finders can be combined using a comma delimiter between parameters that implies an \"and\" statement. |\n| `limit` | Yes | A limit restricts the number of resources returned inside the resource collection. If the limit exceeds the resource count, then the framework will return all available resources. |\n| `offset` | Yes | The offset skips a specified number of items in a data list before it starts showing results. For example, if you set an offset of 10, it skips the first 10 items and begins showing from the 11th item. |\n| `orderBy` | Yes | The `orderBy` attribute retrieves rows using an order ensuring the response payload displays data in the order supplied in the URL parameter using the GET method. |\n\n## poNonStockItem Finders\n\n| Finder | Parameter | Data Type | Description | Example | Mandatory |\n| --- | --- | --- | --- | --- | --- |\n| NonStockItemFinder | PONSI_COMP_CODE | String | Compnay Code | /po-rest-api/rest/1/pononstockitem?finder=NonStockItemFinder.PONSI_COMP_CODE=ALT | Optional |\n| NonStockItemFinder | PONSI_COST_CODE | String | Cost Code | /po-rest-api/rest/1/pononstockitem?finder=NonStockItemFinder.PONSI_COST_CODE=01.9 | Optional |\n| NonStockItemFinder | PONSI_ITM_CODE | String | Item Code | /po-rest-api/rest/1/pononstockitem?finder=NonStockItemFinder.PONSI_ITM_CODE=WIDGET 1 | Optional |\n| PrimaryKey | PONSI_V_UUID | String | UUID -Unique Identifier | /4160BB81A24F71C0E0630B811DACBBBA | False |\n\n## Attributes\n\n| CMiC UI Fieldname | Object | Name | Description | Type | Data Length | Example | Mandatory |\n| --- | --- | --- | --- | --- | --- | --- | --- |\n| PonsiCompCode | poNonStockItem | PonsiCompCode | Company Code | String | 8 | ALT | True |\n| PonsiItmCode | poNonStockItem | PonsiItmCode | Item Code | String | 16 | WIDGET 1 | True |\n| PonsiItmName | poNonStockItem | PonsiItmName | Item Name | String | 60 | Widget 1 | True |\n| PonsiItmWmCode | poNonStockItem | PonsiItmWmCode | Weight Measure Code | String | 2 | EA | True |\n| PonsiItmLstPriceAmt | poNonStockItem | PonsiItmLstPriceAmt | Last Price | Number | 18/4 | 20.0 | False |\n| PonsiItmMinOrdQty | poNonStockItem | PonsiItmMinOrdQty | Min Ord | Number | 6/0 | 1 | False |\n| PonsiItmTax1Code | poNonStockItem | PonsiItmTax1Code | Tax1 Code | String | 11 | 01 | False |\n| PonsiItmTax2Code | poNonStockItem | PonsiItmTax2Code | Tax2 Code | String | 11 | T5 | False |\n| PonsiItmTax3Code | poNonStockItem | PonsiItmTax3Code | Tax3 Code | String | 11 | T6 | False |\n| PonsiAccCode | poNonStockItem | PonsiAccCode | Account Code | String | 16 | 5000.106 | False |\n| PonsiInternalSalesAccCode | poNonStockItem | PonsiInternalSalesAccCode | Internal Sales Account Code | String | 16 | 4000.800 | False |\n| PonsiCatCode | poNonStockItem | PonsiCatCode | Category Code | String | 16 | 4000 | False |\n| PonsiItmDesc | poNonStockItem | PonsiItmDesc | Item Description | String | 4000 | SALES REV | False |\n| PonsiCostCode | poNonStockItem | PonsiCostCode | Cost Code | String | 16 | 01.9 | False |\n| PonsiVUuid | poNonStockItem | PonsiVUuid | Unique Identifier | String | 64 | 4160BB81A24F71C0E0630B811DACBBBA | False |", "parameters": [ { "name": "limit", "in": "query", "schema": { "type": "integer" }, "example": "25" }, { "name": "offset", "in": "query", "schema": { "type": "integer" }, "example": "0" }, { "name": "totalResults", "in": "query", "schema": { "type": "boolean" }, "example": "true" }, { "name": "orderBy", "in": "query", "schema": { "type": "string" }, "example": "PonsiItmCode:asc" }, { "name": "finder", "in": "query", "schema": { "type": "string" }, "example": "NonStockItemFinder; CompCode=ZZ,ItemCode=WD,CostCode=03-700" } ], "responses": { "200": { "description": "OK", "headers": { "Content-Type": { "schema": { "type": "string", "example": "application/vnd.oracle.adf.resourcecollection+json" } } }, "content": { "text/plain": { "schema": { "type": "string" }, "example": "{\n \"items\": [\n {\n \"PonsiAccCode\": \"1000.100.12345\",\n \"PonsiCatCode\": \"1000\",\n \"PonsiCompCode\": \"ZZ\",\n \"PonsiCostCode\": \"03-700\",\n \"PonsiInternalSalesAccCode\": null,\n \"PonsiItmCode\": \"WD\",\n \"PonsiItmDesc\": \"fdfsgfgfd\",\n \"PonsiItmLstPriceAmt\": 150.12,\n \"PonsiItmMinOrdQty\": 25,\n \"PonsiItmName\": \"Widget D\",\n \"PonsiItmTax1Code\": null,\n \"PonsiItmTax2Code\": null,\n \"PonsiItmTax3Code\": null,\n \"PonsiItmWmCode\": \"EA\",\n \"PonsiVUuid\": \"4160BB81A27471C0E0630B811DACBBBA\",\n \"links\": [\n {\n \"rel\": \"self\",\n \"href\": \"http://127.0.0.1:7101/po-rest-api/rest/1/poNonStockItem/4160BB81A27471C0E0630B811DACBBBA\",\n \"name\": \"poNonStockItem\",\n \"kind\": \"item\"\n },\n {\n \"rel\": \"canonical\",\n \"href\": \"http://127.0.0.1:7101/po-rest-api/rest/1/poNonStockItem/4160BB81A27471C0E0630B811DACBBBA\",\n \"name\": \"poNonStockItem\",\n \"kind\": \"item\"\n }\n ]\n }\n ],\n \"totalResults\": 1,\n \"count\": 1,\n \"hasMore\": false,\n \"limit\": 25,\n \"offset\": 0,\n \"links\": [\n {\n \"rel\": \"self\",\n \"href\": \"http://127.0.0.1:7101/po-rest-api/rest/1/poNonStockItem\",\n \"name\": \"poNonStockItem\",\n \"kind\": \"collection\"\n }\n ]\n}" } } } } } } }, "components": { "securitySchemes": { "cmicBasicAuth": { "type": "http", "scheme": "basic", "description": "Basic authentication" } } } } ````